﻿Imports System.ComponentModel
Imports System.Net
Imports System.Net.Sockets
Imports System.Text

Imports DimensionEngineering



Public Class FMain



    Public sim As New Simulator


    Private Shared listenPortWind As Integer = 50001
    Private Shared listenPortGSeat As Integer = 50002
    Private Shared listenPort6DOF As Integer = 50003

    Private Shared HostIP As IPAddress = IPAddress.Parse("127.0.0.1")

    Private wind_sabertooth As Sabertooth

    Private lower_flaps As New Kangaroo.KangarooSerial()
    Private back_flaps As New Kangaroo.KangarooSerial()

    Private lower_left As Kangaroo.KangarooChannel
    Private lower_right As Kangaroo.KangarooChannel
    Private back_left As Kangaroo.KangarooChannel
    Private back_right As Kangaroo.KangarooChannel


    Private use_gseat As Boolean = False

    Private auto_6dof As Boolean = False
    Private origin_6dof_set As Boolean = False
    Private auto_6dof_step_delay As Integer
    Private auto_6dof_start_delay As Integer = 3000
    Private auto_6dof_end_delay As Integer = 10
    Private auto_6dof_speed_rampup_time_step As Integer = 30



    Private back_heave_positive_range As Integer
    Private back_heave_negative_range As Integer
    Private back_accel_range As Integer
    Private back_decel_range As Integer
    Private back_turn_inner_range As Integer
    Private back_turn_outer_range As Integer

    Private seat_heave_positive_range As Integer
    Private seat_heave_negative_range As Integer
    Private seat_accel_range As Integer
    Private seat_decel_range As Integer
    Private seat_turn_inner_range As Integer
    Private seat_turn_outer_range As Integer

    Private back_neutral As Integer
    Private seat_neutral As Integer



    Private g_seat_sway_coef As Single
    Private g_seat_surge_coef As Single


    Private origin_set(6) As Boolean
    Private origin_buttons(6) As Button


    Private gseat_back_flaps_position_range As Integer = 4500



    Private Sub FMain_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not BackgroundWorker1.IsBusy = True Then
            BackgroundWorker1.RunWorkerAsync()
        End If

        If Not BackgroundWorker2.IsBusy = True Then
            BackgroundWorker2.RunWorkerAsync()
        End If

        If Not BackgroundWorker3.IsBusy = True Then
            BackgroundWorker3.RunWorkerAsync()
        End If


        Try
            wind_sabertooth = New Sabertooth("COM15", 9600)
        Catch ex As Exception

        End Try


        Try
            'lower_flaps.Open("COM10", 115200)
            back_flaps.Open("COM19", 115200)
        Catch ex As Exception

        End Try


        'lower_left = New Kangaroo.KangarooChannel(lower_flaps, "1")
        'lower_right = New Kangaroo.KangarooChannel(lower_flaps, "2")
        back_left = New Kangaroo.KangarooChannel(back_flaps, "1")
        back_right = New Kangaroo.KangarooChannel(back_flaps, "2")



        Try
            serial6DOF.Open()

            serial6DOF.Write("<S,0,0,1000>")
            serial6DOF.Write("<E,0,0,0000>")
        Catch ex As Exception

        End Try




        For i = 1 To 6
            origin_set(i) = False
        Next

        origin_buttons(1) = btnM1Origin
        origin_buttons(2) = btnM2Origin
        origin_buttons(3) = btnM3Origin
        origin_buttons(4) = btnM4Origin
        origin_buttons(5) = btnM5Origin
        origin_buttons(6) = btnM6Origin



    End Sub

    Private Sub FMain_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing



        BackgroundWorker1.CancelAsync()
        BackgroundWorker2.CancelAsync()
        BackgroundWorker3.CancelAsync()


        Try
            wind_sabertooth.Motor(1, 0)
        Catch ex As Exception

        End Try



        If serial6DOF.IsOpen Then
            serial6DOF.Close()
        End If


    End Sub



    Private Sub BackgroundWorker1_DoWork(sender As Object, e As DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim worker As BackgroundWorker = CType(sender, BackgroundWorker)

        Dim done As Boolean = False
        Dim listener As New UdpClient(listenPortWind)
        Dim groupEP As New IPEndPoint(HostIP, listenPortWind)
        Dim mystring As String

        Try
            While Not done
                If BackgroundWorker1.CancellationPending = True Then
                    e.Cancel = True
                    listener.Close()
                    Exit While
                Else
                    If (listener.Available > 0) Then
                        Dim bytes As Byte() = listener.Receive(groupEP)
                        mystring = Encoding.ASCII.GetString(bytes, 0, bytes.Length)
                        worker.ReportProgress(0, mystring)
                    End If

                End If
            End While

        Catch ex As Exception

        Finally
            listener.Close()
        End Try

    End Sub


    Private Sub BackgroundWorker2_DoWork(sender As Object, e As DoWorkEventArgs) Handles BackgroundWorker2.DoWork
        Dim worker As BackgroundWorker = CType(sender, BackgroundWorker)

        Dim done As Boolean = False
        Dim listener As New UdpClient(listenPortGSeat)
        Dim groupEP As New IPEndPoint(HostIP, listenPortGSeat)
        Dim mystring As String

        Try
            While Not done
                If BackgroundWorker2.CancellationPending = True Then
                    e.Cancel = True
                    listener.Close()
                    Exit While
                Else
                    If (listener.Available > 0) Then
                        Dim bytes As Byte() = listener.Receive(groupEP)
                        mystring = Encoding.ASCII.GetString(bytes, 0, bytes.Length)
                        worker.ReportProgress(0, mystring)
                    End If

                End If
            End While

        Catch ex As Exception

        Finally
            listener.Close()
        End Try

    End Sub

    Private Sub BackgroundWorker3_DoWork(sender As Object, e As DoWorkEventArgs) Handles BackgroundWorker3.DoWork
        Dim worker As BackgroundWorker = CType(sender, BackgroundWorker)

        Dim done As Boolean = False
        Dim listener As New UdpClient(listenPort6DOF)
        Dim groupEP As New IPEndPoint(HostIP, listenPort6DOF)
        Dim mystring As String

        Try
            While Not done
                If BackgroundWorker1.CancellationPending = True Then
                    e.Cancel = True
                    listener.Close()
                    Exit While
                Else
                    If (listener.Available > 0) Then
                        Dim bytes As Byte() = listener.Receive(groupEP)
                        mystring = Encoding.ASCII.GetString(bytes, 0, bytes.Length)
                        worker.ReportProgress(0, mystring)
                    End If

                End If
            End While

        Catch ex As Exception

        Finally
            listener.Close()
        End Try

    End Sub




    Private Sub BackgroundWorker1_ProgressChanged(sender As Object, e As ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        If (BackgroundWorker1.CancellationPending = False) Then
            Dim speed As Integer = CInt(e.UserState.ToString)

            Call ProcessWind(speed)
        End If
        Update()
    End Sub


    Private Sub ProcessWind(ByVal speed As Integer)

        Dim percentage As Integer = CInt(speed * 100 / My.Settings.wind_max_car_speed)
        percentage = Math.Min(100, percentage)

        Dim wind_power As Integer = CInt(-127 * percentage / 100)

        If speed >= 1 OrElse chkWindManualOn.Checked Then wind_power -= My.Settings.wind_min

        wind_power = Math.Max(Math.Max(-127, wind_power), -1 * My.Settings.wind_max)




        wind_sabertooth.Motor(2, -wind_power)


    End Sub

    Private Sub BackgroundWorker2_ProgressChanged(sender As Object, e As ProgressChangedEventArgs) Handles BackgroundWorker2.ProgressChanged
        If (BackgroundWorker1.CancellationPending = False) Then




            Dim command As String = e.UserState.ToString

            Dim surge As Integer = CInt(command.Split(", ")(0))
            Dim sway As Integer = CInt(command.Split(", ")(1))
            Dim heave As Integer = CInt(command.Split(", ")(2))

            Dim bl As Integer = back_neutral
            Dim br As Integer = back_neutral

            Dim sl As Integer = seat_neutral
            Dim sr As Integer = seat_neutral



            If surge > 2047 Then

                ' acceleration

                ' move back flaps forward
                ' move seat flaps down

                Dim ratio As Single = g_seat_surge_coef / 100 * (surge - 2047) / 2047

                bl -= ratio * back_accel_range
                br -= ratio * back_accel_range

                sl += ratio * seat_accel_range
                sr += ratio * seat_accel_range
            End If

            If surge < 2047 Then
                ' deceleration

                ' move back flaps back
                ' move seat flaps up

                Dim ratio As Single = g_seat_surge_coef / 100 * (surge - 2047) / -2047

                bl += ratio * back_decel_range
                br += ratio * back_decel_range

                sr += ratio * seat_decel_range
                sr += ratio * seat_decel_range

            End If


            If sway > 2047 Then

                ' right turn

                ' increase pressure on the left
                ' decrease pressure on the right

                Dim ratio As Single = g_seat_sway_coef / 100 * (sway - 2047) / 2047

                bl -= ratio * back_turn_outer_range
                sl -= ratio * seat_turn_outer_range

                br += ratio * back_turn_inner_range
                sr += ratio * seat_turn_inner_range

            End If

            If sway < 2047 Then

                ' left turn

                ' increase pressure on the right
                ' decrease pressure on the left

                Dim ratio As Single = g_seat_sway_coef / 100 * (sway - 2047) / -2047

                br -= ratio * back_turn_outer_range
                sr -= ratio * seat_turn_outer_range

                bl += ratio * back_turn_inner_range
                sl += ratio * seat_turn_inner_range

            End If


            If heave > 2047 Then

                ' bump

                ' increase pressure of all flaps

                Dim ratio As Single = (heave - 2047) / 2047

                sl -= ratio * seat_heave_positive_range
                sr -= ratio * seat_heave_positive_range

                bl -= ratio * back_heave_positive_range
                br -= ratio * back_heave_positive_range

            End If

            If heave < 2047 Then

                ' pothole

                ' decrease pressure of all flaps

                Dim ratio As Single = (heave - 2047) / -2047

                sl += ratio * seat_heave_negative_range
                sr += ratio * seat_heave_negative_range

                bl += ratio * back_heave_negative_range
                br += ratio * back_heave_negative_range

            End If


            br = Math.Max(Math.Min(gseat_back_flaps_position_range, br), 0)
            bl = Math.Max(Math.Min(gseat_back_flaps_position_range, bl), 0)
            'sr = Math.Max(Math.Min(5000, sr), 0)
            'sl = Math.Max(Math.Min(5000, sl), 0)



            If use_gseat Then

                back_left.P(bl)
                back_right.P(br)

                'lower_left.P(sl)
                'lower_right.P(sr)
            End If

            'Debug.Print("br=" & br.ToString & " bl=" & bl.ToString & " sr=" & sr.ToString & " sl=" & sl.ToString)


        End If

        Update()


    End Sub







    Private Sub chkUseGSeat_CheckedChanged(sender As Object, e As EventArgs) Handles chkUseGSeat.CheckedChanged

        If Not chkUseGSeat.Checked Then
            use_gseat = False
        Else

            'lower_left.Start()
            'lower_left.Home().Wait()
            'lower_left.P(5000)

            'lower_right.Start()
            'lower_right.Home().Wait()
            'lower_right.P(5000)


            back_left.Start()
            back_left.Home().Wait()
            back_left.P(back_neutral)

            back_right.Start()
            back_right.Home().Wait()
            back_right.P(back_neutral)


            use_gseat = True
        End If




    End Sub

    Private Sub GSeat_ParameterChanged() Handles UcParameterSlider7.ParameterChanged, UcParameterSlider6.ParameterChanged, UcParameterSlider5.ParameterChanged, UcParameterSlider4.ParameterChanged, UcParameterSlider3.ParameterChanged, UcParameterSlider2.ParameterChanged, UcParameterSlider17.ParameterChanged, UcParameterSlider16.ParameterChanged, UcParameterSlider15.ParameterChanged, UcParameterSlider14.ParameterChanged, UcParameterSlider13.ParameterChanged, UcParameterSlider12.ParameterChanged, UcParameterSlider11.ParameterChanged, UcParameterSlider1.ParameterChanged, UcParameterSlider28.ParameterChanged, UcParameterSlider27.ParameterChanged

        seat_neutral = gseat_back_flaps_position_range - My.Settings.seat_neutral_position / 100 * gseat_back_flaps_position_range
        back_neutral = gseat_back_flaps_position_range - My.Settings.back_neutral_position / 100 * gseat_back_flaps_position_range

        back_heave_positive_range = back_neutral * (My.Settings.back_heave_positive / 100)
        back_heave_negative_range = (gseat_back_flaps_position_range - back_neutral) * (My.Settings.back_heave_negative / 100)
        back_accel_range = back_neutral * (My.Settings.back_acceleration / 100)
        back_decel_range = (gseat_back_flaps_position_range - back_neutral) * (My.Settings.back_deceleration / 100)
        back_turn_inner_range = (gseat_back_flaps_position_range - back_neutral) * (My.Settings.back_turn_inner / 100)
        back_turn_outer_range = back_neutral * (My.Settings.back_turn_outer / 100)

        seat_heave_positive_range = seat_neutral * (My.Settings.seat_heave_positive / 100)
        seat_heave_negative_range = (5000 - seat_neutral) * (My.Settings.seat_heave_negative / 100)
        seat_accel_range = (5000 - seat_neutral) * (My.Settings.back_acceleration / 100)
        seat_decel_range = seat_neutral * (My.Settings.seat_deceleration / 100)
        seat_turn_inner_range = (5000 - seat_neutral) * (My.Settings.seat_turn_inner / 100)
        seat_turn_outer_range = seat_neutral * (My.Settings.seat_turn_outer / 100)



        g_seat_surge_coef = My.Settings.gseat_surge_coef
        g_seat_sway_coef = My.Settings.gseat_sway_coef

    End Sub

    Private Sub Calc6DOF(ByVal dof As String)

        Dim surge As Integer
        Dim sway As Integer
        Dim heave As Integer
        Dim roll As Integer
        Dim pitch As Integer
        Dim tl As Integer


        surge = CInt(dof.Split(",")(0))
        sway = CInt(dof.Split(",")(1))
        heave = CInt(dof.Split(",")(2))
        roll = CInt(dof.Split(",")(3))
        pitch = CInt(dof.Split(",")(4))
        tl = CInt(dof.Split(",")(5))



        sim.heave = sim.TwelveBitsToDOF(heave, "heave")
        sim.surge = sim.TwelveBitsToDOF(surge, "surge")
        sim.sway = sim.TwelveBitsToDOF(sway, "sway")
        sim.roll = sim.TwelveBitsToDOF(roll, "roll")
        sim.pitch = sim.TwelveBitsToDOF(pitch, "pitch")
        sim.tl = sim.TwelveBitsToDOF(tl, "tl")

        sim.surge_pitch_component = -1 * sim.TwelveBitsToDOF(surge, "surge_pitch")
        sim.sway_roll_component = -1 * sim.TwelveBitsToDOF(sway, "sway_roll")




        sim.UpdateCoordinates()



    End Sub





    Private Sub BackgroundWorker3_ProgressChanged(sender As Object, e As ProgressChangedEventArgs) Handles BackgroundWorker3.ProgressChanged

        If Not auto_6dof Then Exit Sub


        If (BackgroundWorker1.CancellationPending = False) Then

            Dim dof As String = e.UserState.ToString

            Call Calc6DOF(dof)

        End If
        Update()
    End Sub



    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles timerAuto6DOF.Tick

        If Not auto_6dof Then
            timerAuto6DOF.Enabled = False
            Exit Sub
        End If


        ' ramp up speed
        If auto_6dof_step_delay > auto_6dof_end_delay Then
            Static prev_rampup_time As DateTime = Now

            Dim milliseconds_after_previous_rampup As Integer = (Now - prev_rampup_time).TotalMilliseconds

            If milliseconds_after_previous_rampup > auto_6dof_speed_rampup_time_step Then
                auto_6dof_step_delay -= 10
                auto_6dof_step_delay = Math.Max(auto_6dof_step_delay, auto_6dof_end_delay)
                serial6DOF.Write("<S,0,0," & auto_6dof_step_delay.ToString.PadLeft(4, "0") & ">")

                prev_rampup_time = Now

                Debug.Print(auto_6dof_step_delay)
            End If




        End If


        Call Send6DOFTargets()

    End Sub

    Private Sub Send6DOFTargets()

        Dim positions As String = "<"
        Dim i As Integer = 0

        For i = 1 To 6

            Try
                positions &= CType(sim.actuators.Item(i.ToString), Actuator).Target.ToString.PadLeft(4, "0")
            Catch ex As Exception
                ' target angle could not be calculated
                Exit Sub
            End Try


            If i < 6 Then
                positions &= ","
            Else
                positions &= ">"
            End If

        Next i

        serial6DOF.Write(positions)


    End Sub









    Private manual_direction As String = ""
    Private manual_motor As Integer = 0
    Private Sub btnMUp_MouseDown(sender As Object, e As MouseEventArgs) Handles btnAllUp.MouseDown, btnM6Up.MouseDown, btnM5Up.MouseDown, btnM4Up.MouseDown, btnM3Up.MouseDown, btnM2Up.MouseDown, btnM1Up.MouseDown
        manual_direction = "U"
        manual_motor = sender.tag

        timerManualActuatorControl.Enabled = True
    End Sub

    Private Sub btnMUp_MouseUp(sender As Object, e As MouseEventArgs) Handles btnAllUp.MouseUp, btnM6Up.MouseUp, btnM5Up.MouseUp, btnM4Up.MouseUp, btnM3Up.MouseUp, btnM2Up.MouseUp, btnM1Up.MouseUp
        timerManualActuatorControl.Enabled = False
    End Sub

    Private Sub btnMDn_MouseDown(sender As Object, e As MouseEventArgs) Handles btnAllDn.MouseDown, btnM6Dn.MouseDown, btnM5Dn.MouseDown, btnM4Dn.MouseDown, btnM3Dn.MouseDown, btnM2Dn.MouseDown, btnM1Dn.MouseDown
        manual_direction = "D"
        manual_motor = sender.tag

        timerManualActuatorControl.Enabled = True
    End Sub

    Private Sub btnMDn_MouseUp(sender As Object, e As MouseEventArgs) Handles btnAllDn.MouseUp, btnM6Dn.MouseUp, btnM5Dn.MouseUp, btnM4Dn.MouseUp, btnM3Dn.MouseUp, btnM2Dn.MouseUp, btnM1Dn.MouseUp
        timerManualActuatorControl.Enabled = False
    End Sub











    Private serial_buffer As String = ""
    Private Sub serial6DOF_DataReceived(sender As Object, e As IO.Ports.SerialDataReceivedEventArgs) Handles serial6DOF.DataReceived


        serial_buffer &= serial6DOF.ReadExisting()


        While True
            Try
                Dim packet_start As Integer = serial_buffer.IndexOf("<")
                Dim packet_end As Integer = serial_buffer.IndexOf(">", packet_start)

                Dim packet_len As Integer = packet_end - packet_start - 1

                Dim packet As String = serial_buffer.Substring(packet_start + 1, packet_len)


                serial_buffer = serial_buffer.Substring(packet_end + 1)

                Call ProcessSerialPacket(packet)
            Catch ex As ArgumentOutOfRangeException
                Exit While
            End Try

        End While





    End Sub

    Private Sub ProcessSerialPacket(ByVal packet As String)
        If packet = "ESTOP" Then
            With lbl6DOFStatus
                .BackColor = Color.Orange
                .ForeColor = Color.DarkRed
            End With
            lbl6DOFStatus.BeginInvoke(Sub() lbl6DOFStatus.Text = "ESTOP")


            origin_6dof_set = False
            auto_6dof = False

            chkManualControl.BeginInvoke(Sub() chkAuto6DOF.Enabled = False)
            chkManualControl.BeginInvoke(Sub() chkAuto6DOF.Checked = False)

            chkManualControl.BeginInvoke(Sub() chkManualControl.Checked = False)

            timerManualActuatorControl.Enabled = False


        ElseIf packet = "OK" Then
            With lbl6DOFStatus
                .BackColor = Color.PaleGreen
                .ForeColor = Color.DarkGreen
            End With

            lbl6DOFStatus.BeginInvoke(Sub() lbl6DOFStatus.Text = "OK")
        Else
            Debug.Print(packet)
        End If
    End Sub

    Private Sub EnableManualButtons()
        btnM1Dn.Enabled = chkManualControl.Checked
        btnM2Dn.Enabled = chkManualControl.Checked
        btnM3Dn.Enabled = chkManualControl.Checked
        btnM4Dn.Enabled = chkManualControl.Checked
        btnM5Dn.Enabled = chkManualControl.Checked
        btnM6Dn.Enabled = chkManualControl.Checked

        btnM1Up.Enabled = chkManualControl.Checked
        btnM2Up.Enabled = chkManualControl.Checked
        btnM3Up.Enabled = chkManualControl.Checked
        btnM4Up.Enabled = chkManualControl.Checked
        btnM5Up.Enabled = chkManualControl.Checked
        btnM6Up.Enabled = chkManualControl.Checked


        btnM1Origin.Enabled = chkManualControl.Checked
        btnM2Origin.Enabled = chkManualControl.Checked
        btnM3Origin.Enabled = chkManualControl.Checked
        btnM4Origin.Enabled = chkManualControl.Checked
        btnM5Origin.Enabled = chkManualControl.Checked
        btnM6Origin.Enabled = chkManualControl.Checked


        btnAllDn.Enabled = chkManualControl.Checked
        btnAllUp.Enabled = chkManualControl.Checked



        btnSetOriginAll.Enabled = chkManualControl.Checked


    End Sub


    Private Sub chkManualControl_CheckedChanged(sender As Object, e As EventArgs) Handles chkManualControl.CheckedChanged
        If chkManualControl.Checked Then

            serial6DOF.Write("<E,0,0,0000>")

            chkAuto6DOF.Checked = False

            serial6DOF.Write("<S,0,0,0010>")



        End If

        Call EnableManualButtons()


    End Sub

    Private Sub chkAuto6DOF_CheckedChanged(sender As Object, e As EventArgs) Handles chkAuto6DOF.CheckedChanged
        If chkAuto6DOF.Checked Then chkManualControl.Checked = False

        Call EnableManualButtons()


        auto_6dof_step_delay = auto_6dof_start_delay

        serial6DOF.Write("<S,0,0," & auto_6dof_step_delay.ToString.PadLeft("0") & ">")

        If chkAuto6DOF.Checked Then
            auto_6dof = True
            timerAuto6DOF.Interval = 1
            timerAuto6DOF.Enabled = True
        Else
            auto_6dof = False
            timerAuto6DOF.Enabled = False
        End If

    End Sub

    Private Sub timerManualActuatorControl_Tick(sender As Object, e As EventArgs) Handles timerManualActuatorControl.Tick
        If manual_motor = 0 Then
            Dim i As Integer
            For i = 1 To 6
                serial6DOF.Write("<M," & i.ToString & "," & manual_direction & ",0005>")
            Next
        Else
            serial6DOF.Write("<M," & manual_motor.ToString & "," & manual_direction & ",0005>")
        End If




    End Sub

    Private Sub btnSetOrigin_Click(sender As Object, e As EventArgs) Handles btnSetOriginAll.Click

        serial6DOF.Write("<N,0,0,5000>")


        For i = 1 To 6
            origin_set(i) = True
        Next

        Call CheckOrigins()

    End Sub



    Private Sub UcParameterSlider26_ParameterChanged() Handles UcParameterSlider26.ParameterChanged, UcParameterSlider25.ParameterChanged, UcParameterSlider24.ParameterChanged, UcParameterSlider23.ParameterChanged, UcParameterSlider22.ParameterChanged, UcParameterSlider21.ParameterChanged, UcParameterSlider20.ParameterChanged, UcParameterSlider19.ParameterChanged, UcParameterSlider18.ParameterChanged
        Call sim.UpdateLimits()
    End Sub

    Private Sub SetMotorOrigin(sender As Object, e As EventArgs) Handles btnM6Origin.Click, btnM5Origin.Click, btnM4Origin.Click, btnM3Origin.Click, btnM2Origin.Click, btnM1Origin.Click
        Dim motor_id As Integer = CInt(sender.tag)

        serial6DOF.Write("<N," & motor_id.ToString & ",0,5000>")

        origin_set(motor_id) = True

        Call CheckOrigins()
    End Sub

    Private Function CheckOrigins() As Boolean
        Dim all_origins_set As Boolean = True

        For i = 1 To 6
            If Not origin_set(i) Then
                all_origins_set = False
                origin_buttons(i).BackColor = Color.DarkRed
            Else
                origin_buttons(i).BackColor = Color.PaleGreen
            End If
        Next

        origin_6dof_set = all_origins_set
        chkAuto6DOF.Enabled = all_origins_set




        Return all_origins_set

    End Function

    Private Sub chkWindManualOn_CheckedChanged(sender As Object, e As EventArgs) Handles chkWindManualOn.CheckedChanged
        Call ProcessWind(0)
    End Sub

    Private Sub btnSaveSettings_Click(sender As Object, e As EventArgs) Handles btnSaveSettings.Click
        If dialogSaveSettings.ShowDialog = DialogResult.OK Then
            Call MSettings.SaveSettings(dialogSaveSettings.FileName)
        End If

    End Sub

    Private Sub btnLoadSettings_Click(sender As Object, e As EventArgs) Handles btnLoadSettings.Click

        If dialogLoadSettings.ShowDialog = DialogResult.OK Then
            Call MSettings.LoadSettings(dialogLoadSettings.FileName)

            Call UpdateParameterSlider(Me)
        End If

    End Sub

    Private Sub UpdateParameterSlider(ByVal parent As Control)
        If TypeOf parent Is ucParameterSlider Then
            CType(parent, ucParameterSlider).ShowParameter()
        Else
            For Each ctrl In parent.Controls
                Call UpdateParameterSlider(ctrl)
            Next
        End If
    End Sub




End Class
